#include <iostream>
#include <sstream>
#include <Windows.h>
#include "usb_monitor.h"

void device_added(char letter)
{
	std::cout << "Added USB disk: " << letter << std::endl;
}

void device_removed(char letter)
{
	std::cout << "UNSAFE-removed USB disk: " << letter << std::endl;
}

bool device_safe_removed(char letter)
{
	std::wstringstream ss;
	ss << L"   " << static_cast<wchar_t>(letter) << L":?";
	if(MessageBox(0, ss.str().c_str(), L"?", MB_ICONQUESTION | MB_YESNO) == IDYES)
	{
		std::cout << "Safe-removed USB disk: " << letter << std::endl;
		return true;
	}
	else
	{
		return false;
	}
}

void device_remove_failed(char letter)
{
	std::cout << "Failed to eject device: " << letter << std::endl;
}

int main()
{
	usb_monitor* mon = usb_monitor::create();
	mon->on_device_add(device_added);
	mon->on_device_remove(device_removed);
	mon->on_device_safe_remove(device_safe_removed);
	mon->on_device_remove_fail(device_remove_failed);

	mon->mount_existing_devices();

	mon->start();

	usb_monitor::message_pump();
	return 0;
}
